﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Csla.Silverlight;
using Rolodex.Business.BusinessClasses;

namespace Rolodex
{
  public partial class CompanyEditor : UserControl
  {
    private int _companyID;
    public CompanyEditor()
    {
      InitializeComponent();
    }

    public CompanyEditor(int companyID)
    {
      InitializeComponent();
      _companyID = companyID;
    }

 

    private void CslaDataProvider_DataChanged(object sender, EventArgs e)
    {

      CslaDataProvider provider = ((CslaDataProvider)this.Resources["CompanyData"]);
      this.Contacts.SelectedItem = null;
      if (provider.Data != null && ((Company)(provider.Data)).Contacts.Count > 0)
      {
        this.Dispatcher.BeginInvoke(()=>
          {
            this.Contacts.SelectedItem = ((Company)(provider.Data)).Contacts[0];
            this.Contacts.Focus();
          });
      }
      if (provider.Error != null)
        MessageBox.Show(((Csla.Silverlight.CslaDataProvider)sender).Error.Message);
    }

    private void CloseButton_Click(object sender, RoutedEventArgs e)
    {
      Page.ShowControl(new CompaniesList());
    }

    private void AddContactButton_Click(object sender, RoutedEventArgs e)
    {
      if (((CslaDataProvider)this.Resources["CompanyData"]).Data != null)
      {
        ((Company)((CslaDataProvider)this.Resources["CompanyData"]).Data).Contacts.AddNew();
      }
    }

    private void DeleteContact_Click(object sender, RoutedEventArgs e)
    {
      ((Company)((CslaDataProvider)this.Resources["CompanyData"]).Data).Contacts.Remove((CompanyContact)((Button)sender).Tag);
    }

    private void AddContactPhoneButton_Click(object sender, RoutedEventArgs e)
    {
      if (this.Contacts.SelectedItem != null)
      {
        CompanyContact selectedContact = this.Contacts.SelectedItem as CompanyContact;
        selectedContact.ContactPhones.AddNew();
      }
    }

    private void DeleteContactPhone_Click(object sender, RoutedEventArgs e)
    {
      if (this.Contacts.SelectedItem != null)
      {
        CompanyContact selectedContact = this.Contacts.SelectedItem as CompanyContact;
        selectedContact.ContactPhones.Remove((CompanyContactPhone)((Button)sender).Tag);
      }
    }


    private void Contacts_SelectionChanged(object sender, SelectionChangedEventArgs e)
    {
      if (this.Contacts.SelectedItem == null)
      {
        this.ContactsPhones.ItemsSource = null;
      }
      else
      {
        this.ContactsPhones.ItemsSource = ((CompanyContact)this.Contacts.SelectedItem).ContactPhones;
      }
    }

    private void UserControl_Loaded(object sender, RoutedEventArgs e)
    {
      if (_companyID == 0)
      {
        CslaDataProvider provider = ((CslaDataProvider)this.Resources["CompanyData"]);
        provider.FactoryMethod = "CreateCompany";
        provider.FactoryParameters.Clear();
        provider.Refresh();
      }
      else
      {
        CslaDataProvider provider = this.Resources["CompanyData"] as CslaDataProvider;
        provider.FactoryParameters.Clear();
        provider.FactoryParameters.Add(_companyID);
        provider.FactoryMethod = "GetCompany";
        provider.Refresh();
      }
    }

  }
}
