﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Csla;
using Csla.Security;
using Csla.Core;
using Csla.Serialization;
using Csla.Silverlight;
using Csla.Validation;

#if!SILVERLIGHT
using System.Data.SqlClient;
using Rolodex.Business.Data;
using Csla.Data;
using RolodexEF;
#endif

namespace Rolodex.Business.BusinessClasses
{
  [Serializable]
  public class CompanyContactList : BusinessListBase<CompanyContactList, CompanyContact>
  {

    internal Company ParentCompany
    {
      get
      {
        return this.Parent as Company;
      }
    }

#if SILVERLIGHT
    public CompanyContactList() { }
    protected override void AddNewCore()
    {
      CompanyContact newContact = CompanyContact.NewCompanyContact();
      Add(newContact);
    }
#else
    private CompanyContactList() { }
    protected override object AddNewCore()
    {
      CompanyContact newContact = CompanyContact.NewCompanyContact();
      Add(newContact);
      return newContact;
    }
#endif



    internal static CompanyContactList NewCompanyContactList()
    {
      return DataPortal.CreateChild<CompanyContactList>();
    }

    new public void Child_Create()
    {
      base.Child_Create();
    }

#if !SILVERLIGHT

    internal static CompanyContactList GetCompanyContactList(Companies company)
    {
      return DataPortal.FetchChild<CompanyContactList>(company);
    }

    private void Child_Fetch(Companies company)
    {
      this.RaiseListChangedEvents = false;
      foreach (var item in company.CompanyContacts)
      {
       Add(CompanyContact.GetCompanyContact(item));
      }
      this.RaiseListChangedEvents = true;
    }

#endif


  }
}
