﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Csla;
using Csla.Security;
using Csla.Core;
using Csla.Serialization;
using Csla.Silverlight;
using Csla.Validation;

#if!SILVERLIGHT
using Csla.Data;
using System.Data.SqlClient;
using Rolodex.Business.Data;
using RolodexEF;
#endif

namespace Rolodex.Business.BusinessClasses
{
  [Serializable]
  public class ReadOnlyCompanyList : ReadOnlyListBase<ReadOnlyCompanyList, ReadOnlyCompany>
  {
#if SILVERLIGHT
    public ReadOnlyCompanyList() { }
#else
    private ReadOnlyCompanyList() { }
#endif

    public static void GetCompanyList(EventHandler<DataPortalResult<ReadOnlyCompanyList>> handler)
    {
      DataPortal<ReadOnlyCompanyList> dp = new DataPortal<ReadOnlyCompanyList>();
      dp.FetchCompleted += handler;
      dp.BeginFetch();
    }

#if !SILVERLIGHT

    private void DataPortal_Fetch()
    {
      RaiseListChangedEvents = false;
      IsReadOnly = false;
      using (ObjectContextManager<RolodexEntities> manager = ObjectContextManager<RolodexEF.RolodexEntities>.GetManager(DataConnection.EFConnectionName, true))
      {
        foreach (var item in manager.ObjectContext.Companies)
        {
          Add(ReadOnlyCompany.GetReadOnlyCompany(item));
        }
      }
      IsReadOnly = true;
      RaiseListChangedEvents = true;
    }

#endif
  }
}
